{-# OPTIONS -cpp -fffi -fglasgow-exts #-}

-- Module:    Data.ByteString.Latin1

-- Manipulate ByteStrings using Char operations, interpreting the strings
-- as Basic Latin/Latin-1 suppl, and C0+C1 Controls.  The only difference
-- to Char8 is that storing non-latin1 characters (codepoints above 255)
-- in an error

module Data.ByteString.Latin1
#include "char_functions.hsi"

charset_name :: String
charset_name = "Latin1"

charset = [0..255]

is_valid :: Char -> Bool
is_valid c = ord c < 256

-- | Conversion between 'Char' and 'Word8'.
c2w :: Char -> Word8
c2w c = if is_valid c then c2w_raw c 
        else err_oor c
{-# INLINE c2w #-}

w2c :: Word8 -> Char
w2c = w2c_raw
{-# INLINE w2c #-}

space,newline :: Word8
space = 0x20
newline = 0x0A

isSpaceWord8 :: Word8 -> Bool
isSpaceWord8 w = case w of 0xA0 -> True    -- NO-BREAK SPACE (ISO 8859-1)
                           _    -> isAsciiSpace w 
{-# INLINE isSpaceWord8 #-}
